' Binary file Input/output demo
' How To save text strings And values To a binary file And retrieve them from it.

' THIS SOURCE CODE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND. USE AT YOUR OWN RISK.

Strict
Framework _3Impact.Lib
Import BRL.Stream

Global Camera:CAMERA
Global FontWhite:FONT

' Defines strings To be used in this example
Global OutputString:String
Global InputString:String
Global MessageString:String
' Defines Float variables To be used in this example
Global OutputValue:Float
Global InputValue:Float

If Not i3ImpactOpen() RuntimeError "Unable to initialize the 3Impact game engine"
If Not i3ImpactSettings(_ISETTINGS(640,480,32,False,True,False)) RuntimeError "Settings failed"

Local engine:sample_3IEngine=New sample_3IEngine

engine.Start()

Type sample_3IEngine Extends _3IEngine

	Method _Init()
	   Camera=iCameraCreate(0.0,0.0,1.0,1.0)
	   FontWhite=iFontCreate("default_res\\fontwhite\\font.wid",Null)
	
	   ' Puts 'Hello World!' text into the string to save to the file
	   OutputString="Hello World!"
	   ' Puts no text into the String that will receive data from the file
	   InputString=""
	
	   ' Puts a value into the numeric variable To save To the file
	   OutputValue = 127.734
	   ' Puts zero into the numeric variable that will receive data from the file
	   InputValue = 0.0
	
	   ' Allocates some Local variables required by the Input/output code
	   Local hFile:TStream
	   Local filepath:String
	   ' Regardless of where the compiled .dll file is installed To, the following line
	   ' fills the 'filepath' string with the full path to the datafile.bin file, the
	   ' file we want To create. This guarantees that the file is created in the same
	   ' directory as the compiled .dll.
	   iGlobalPathMake(filepath,"datafile.bin")

	   ' Creates the file specified in 'filepath' and opens it for writing. Note that if
	   ' a file with the same name exists in the same folder, it is overwritten.
	   hFile=WriteStream(filepath)
	   If (hFile <> Null)
	      ' Writes 200 bytes from the OutputString To the file
		 WriteLine(hFile,OutputString)
	      ' In memory, physically, a Float variable is made of 4 bytes. The following
	      ' code writes the 4 bytes that form the OutputValue variable To the file
	      WriteFloat(hFile,OutputValue)
	      ' Closes the file (never leave a file open when you are done with it!)
	      CloseStream(hFile) 
	   EndIf
	
	   ' Opens the existing file specified in 'filepath' for reading
	   hFile = ReadStream(filepath)
	   If (hFile <> Null)	   
	      ' Reads 200 bytes from the file And put them into the OutputString
		 InputString=ReadLine(hFile)
	      ' Reads the Next 4 bytes from the file And puts them into the four
	      ' bytes of memory that form the InputValue variable
	      InputValue=ReadFloat(hFile)
	      ' Closes the file (never leave a file open when you are done with it!)
	      CloseStream(hFile) 
	   EndIf
	
	   ' Composes a mixed String from InputString And InputValue
	   ' And puts it into the String named 'MessageString'.
	   MessageString=InputString+" "+InputValue
	EndMethod
	
	Method _Run()
	   ' Renders the message String
	   iPrintCentered(MessageString,_D3DXVECTOR2(0.0,0.0),_D3DXVECTOR2(1.0,1.0),0.1,FontWhite,0.0)
	EndMethod
EndType
