' Simple keyboard controlled car with cameraman.
' Controls: arrow keys And [Ctrl] To brake.

' See SimpleCar demo code For comments.

' THIS SOURCE CODE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND. USE AT YOUR OWN RISK.

Strict
Framework _3Impact.Lib
Include "..\common\3impact_cameraman.bmx"

Global Camera:CAMERA
Global LoadingMessage:SPRITE
Global SkyBox:SKYBOX
Global Terrain:BODY
Global TerrainMesh:MESH
Global CarBody:BODY
Global CarBodyMesh:MESH
Global CarBodyMeshShadow:MESH
Global CarWheelFL:BODY
Global CarWheelFLMesh:MESH
Global CarWheelFLMeshShadow:MESH
Global CarWheelFR:BODY
Global CarWheelFRMesh:MESH
Global CarWheelFRMeshShadow:MESH
Global CarWheelRL:BODY
Global CarWheelRLMesh:MESH
Global CarWheelRLMeshShadow:MESH
Global CarWheelRR:BODY
Global CarWheelRRMesh:MESH
Global CarWheelRRMeshShadow:MESH
Global CarBodyTerrain:BODYBODY
Global CarWheelFLTerrain:BODYBODY
Global CarWheelFRTerrain:BODYBODY
Global CarWheelRLTerrain:BODYBODY
Global CarWheelRRTerrain:BODYBODY
Global CarWheelFLJoint:WHEEL
Global CarWheelFRJoint:WHEEL
Global CarWheelRLJoint:WHEEL
Global CarWheelRRJoint:WHEEL
Global SideFriction:Float
Global RollingWiseFriction:Float
Global SuspensionSpring:Float
Global SuspensionDamping:Float
Global SteerAngle:Float
Global Spin:Float
Global WheelSpin:Float
Global WheelPower:Float

Global Envmap:ENVMAP
Global CMKD:CameramanLookAtPointKeepDistance_t=New CameramanLookAtPointKeepDistance_t

If Not i3ImpactOpen() RuntimeError "Unable to initialize the 3Impact game engine"
If Not i3ImpactSettings(_ISETTINGS(640,480,32,False,True,False)) RuntimeError "Settings failed"

Local engine:sample_3IEngine=New sample_3IEngine

engine.Start()

Type sample_3IEngine Extends _3IEngine

	Method _Init()
	   Camera=iCameraCreate(0.0,0.0,1.0,1.0)
	   iCameraFovSet(Camera,35.0)
	   iCameraLocationSet(Camera,_D3DXVECTOR3(23.0,10.0,-70.0))
	   iLightDirectionalSet(_D3DXVECTOR3(1.0,-1.0,1.0),_D3DXVECTOR4(1.0,1.0,1.0,0.35))
	   LoadingMessage=iSpriteCreate("default_res\\sprites\\loading.x",Null)
	   iSpriteRender(LoadingMessage,False)
	   SkyBox=iSkyBoxCreate("default_res\\skyboxes\\skybox01.sky")
	   Terrain=iBodyCreate("default_res\\terrain_5.00.ply")
	   TerrainMesh=iBodyMeshCreate("default_res\\terrain.x",Terrain)
	
	   CarBody=iBodySGCreate("simplecar_res\\bluecar_.spg",1.0)
	   CarBodyMesh=iBodyMeshCreate("simplecar_res\\bluecar.x",CarBody)
	   iBodyLocationSet(CarBody,_D3DXVECTOR3(43.0,5.0,-100.0),True)
	   iBodyDampingSet(CarBody,0.0,0.999,0.0,0.995)
	   CarBodyMeshShadow=iMeshBodyShadowCasterCreate("simplecar_res\\bluecar.x",CarBody,50.0)
	
	   CarBodyTerrain=iBodyBodyCreate(CarBody,Terrain)
	   iBodyBodyFrictionSet(CarBodyTerrain,2.5)
	
	   Local collisionbodies:BODY[10]
	   collisionbodies[0] = Terrain
	   collisionbodies[1] = Null
	   CMKD.Create(Camera,1.0,15.0,2.0,10.0,0.8,0.35,collisionbodies)
	
	   ' ********************************************************
	   ' SIMULATION PARAMETERS: you can adjust car-dynamics here!
	
	   ' the friction produced by wheels, when they move sideways respect To terrain
	   SideFriction = 10.0
	   ' the friction produced by wheels, when they move parallel To rolling direction
	   RollingWiseFriction = 6.0
	   ' suspension strength
	   SuspensionSpring = 30.0
	   ' suspension hardness
	   SuspensionDamping = 2.0
	   ' maximum wheel spin (degrees per second)
	   WheelSpin = 3000.0
	   ' maximum wheel power applied To reach And keep maximum speed
	   WheelPower = 2.0
	
	   ' ********************************************************
	
	   SteerAngle = 0.0
	   Spin = 0.0
	
	   CarWheelFL=iBodySGCreate("simplecar_res\\carwheel_.spg",0.1)
	   CarWheelFLMesh=iBodyMeshCreate("simplecar_res\\carwheel.x",CarWheelFL)
	   CarWheelFLMeshShadow=iMeshBodyShadowCasterCreate("simplecar_res\\carwheel_shadow.x",CarWheelFL,500.0)
	   CarWheelFLTerrain=iBodyBodyCreate(CarWheelFL,Terrain)
	   iBodyBodySplitFrictionSet(CarWheelFLTerrain,SideFriction,0.0,RollingWiseFriction,0.0)
	   CarWheelFLJoint = iWheelCreate(CarBody,CarWheelFL,_D3DXVECTOR3(-0.95,0.05,1.65),Null)
	   iWheelSuspensionSet(CarWheelFLJoint,SuspensionSpring,SuspensionDamping)
	
	   CarWheelFR=iBodySGCreate("simplecar_res\\carwheel_.spg",0.1)
	   CarWheelFRMesh=iBodyMeshCreate("simplecar_res\\carwheel.x",CarWheelFR)
	   CarWheelFRMeshShadow=iMeshBodyShadowCasterCreate("simplecar_res\\carwheel_shadow.x",CarWheelFR,500.0)
	   CarWheelFRTerrain=iBodyBodyCreate(CarWheelFR,Terrain)
	   iBodyBodySplitFrictionSet(CarWheelFRTerrain,SideFriction,0.0,RollingWiseFriction,0.0)
	   CarWheelFRJoint = iWheelCreate(CarBody,CarWheelFR,_D3DXVECTOR3(0.95,0.05,1.65),Null)
	   iWheelSuspensionSet(CarWheelFRJoint,SuspensionSpring,SuspensionDamping)
	
	   CarWheelRL=iBodySGCreate("simplecar_res\\carwheel_.spg",0.1)
	   CarWheelRLMesh=iBodyMeshCreate("simplecar_res\\carwheel.x",CarWheelRL)
	   CarWheelRLMeshShadow=iMeshBodyShadowCasterCreate("simplecar_res\\carwheel_shadow.x",CarWheelRL,500.0)
	   CarWheelRLTerrain=iBodyBodyCreate(CarWheelRL,Terrain)
	   iBodyBodySplitFrictionSet(CarWheelRLTerrain,SideFriction,0.0,RollingWiseFriction,0.0)
	   CarWheelRLJoint = iWheelCreate(CarBody,CarWheelRL,_D3DXVECTOR3(-0.95,0.05,-1.60),Null)
	   iWheelSuspensionSet(CarWheelRLJoint,SuspensionSpring,SuspensionDamping)
	
	   CarWheelRR=iBodySGCreate("simplecar_res\\carwheel_.spg",0.1)
	   CarWheelRRMesh=iBodyMeshCreate("simplecar_res\\carwheel.x",CarWheelRR)
	   CarWheelRRMeshShadow=iMeshBodyShadowCasterCreate("simplecar_res\\carwheel_shadow.x",CarWheelRR,500.0)
	   CarWheelRRTerrain=iBodyBodyCreate(CarWheelRR,Terrain)
	   iBodyBodySplitFrictionSet(CarWheelRRTerrain,SideFriction,0.0,RollingWiseFriction,0.0)
	   CarWheelRRJoint = iWheelCreate(CarBody,CarWheelRR,_D3DXVECTOR3(0.95,0.05,-1.60),Null)
	   iWheelSuspensionSet(CarWheelRRJoint,SuspensionSpring,SuspensionDamping)
	
	   ' Enable some environent mapping For the car body
	   Envmap=iEnvMapCreate("default_res\\envmap.dds")
	   iMeshEnvMapReceiverAdd(CarBodyMesh,Envmap)
	   iMeshEnvMapBlendSet(CarBodyMesh,0.15)
	
	   iBodyEnable(Terrain)
	   iBodyEnable(CarBody)
	   iBodyEnable(CarWheelFL)
	   iBodyEnable(CarWheelFR)
	   iBodyEnable(CarWheelRL)
	   iBodyEnable(CarWheelRR)
	   iSpriteHide(LoadingMessage)
	   iSkyBoxShow(SkyBox)
	   iMeshShow(TerrainMesh)
	   iMeshShow(CarBodyMesh)
	   iMeshShow(CarBodyMeshShadow)
	   iMeshShow(CarWheelFLMesh)
	   iMeshShow(CarWheelFLMeshShadow)
	   iMeshShow(CarWheelFRMesh)
	   iMeshShow(CarWheelFRMeshShadow)
	   iMeshShow(CarWheelRLMesh)
	   iMeshShow(CarWheelRLMeshShadow)
	   iMeshShow(CarWheelRRMesh)
	   iMeshShow(CarWheelRRMeshShadow)
	EndMethod
	Method _Run()
	   Local actorlocation:D3DXVECTOR3=_D3DXVECTOR3()
	   iBodyLocationCM(CarBody,actorlocation)
	   CMKD.Update(actorlocation)
	
	   If (iKeyDown(DIK_LEFT))
	      iFloatTendTo(SteerAngle,20.0,0.3)
	   ElseIf (iKeyDown(DIK_RIGHT))
	      iFloatTendTo(SteerAngle,-20.0,0.3)
	   Else
		 iFloatTendTo(SteerAngle,0.0,0.2)
	   EndIf
	   iWheelSteeringAngleSet(CarWheelFLJoint,SteerAngle)
	   iWheelSteeringAngleSet(CarWheelFRJoint,SteerAngle)
	
	   If (iKeyDown(DIK_UP))
	      iFloatTendTo(Spin,-WheelSpin,0.4)
	   ElseIf (iKeyDown(DIK_DOWN))
	      iFloatTendTo(Spin,WheelSpin,0.4)
	   Else
		 iFloatTendTo(Spin,0.0,0.1)
	   EndIf
	
	   Local power:Float = iFloatInterpolate(iFloatAbs(Spin),0.0,WheelSpin,WheelPower*0.1,WheelPower,False)
	
	   If ((iKeyDown(DIK_LCONTROL)) Or (iKeyDown(DIK_RCONTROL)))
	      Spin = 0.0
	      power = 5.0
	   EndIf
	
	   iWheelSpinSet(CarWheelFLJoint,Spin)
	   iWheelSpinSet(CarWheelFRJoint,Spin)
	   iWheelSpinSet(CarWheelRLJoint,Spin)
	   iWheelSpinSet(CarWheelRRJoint,Spin)
	   iWheelPowerSet(CarWheelFLJoint,power)
	   iWheelPowerSet(CarWheelFRJoint,power)
	   iWheelPowerSet(CarWheelRLJoint,power)
	   iWheelPowerSet(CarWheelRRJoint,power)
	
	   iBodyAccelerationApply(CarBody,_D3DXVECTOR3(0.0,-9.80665,0.0))
	   iBodyAccelerationApply(CarWheelFL,_D3DXVECTOR3(0.0,-9.80665,0.0))
	   iBodyAccelerationApply(CarWheelFR,_D3DXVECTOR3(0.0,-9.80665,0.0))
	   iBodyAccelerationApply(CarWheelRL,_D3DXVECTOR3(0.0,-9.80665,0.0))
	   iBodyAccelerationApply(CarWheelRR,_D3DXVECTOR3(0.0,-9.80665,0.0))
	EndMethod
	Method _Exit()
	   CMKD=Null
	EndMethod
EndType




