' 2006/02/22 GG - added new iBodyMeshPartCreate() and iBodyMeshPartCreateFromMemory() implemented in v4.1.0

' -------------------------------------------------------
' BODY
' -------------------------------------------------------

Type BODY Extends i3ImpactBase	

	Method Destroy()
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyDestroy(objptr)
		objptr=Null
	EndMethod

	Method Disable()
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyDisable(objptr)
	EndMethod
	
	Method Enable()
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyEnable(objptr)
	EndMethod		

	Method Status:Int()
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return 0
		EndIf	
		Return _iBodyStatus(objptr)
	EndMethod

	Method MeshCreate:MESH(x_filename:String,generateFunc:Byte Ptr=Null)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return Null
		EndIf	
		Local retval:MESH
		If generateFunc<>Null
			Local genFunc:MESH()=generateFunc
			retval=genFunc()
		Else
			retval=_g_3IEngine.generateMesh()
		EndIf
		retval.objptr=_iBodyMeshCreate(x_filename,objptr)
		If retval.objptr<>Null Then Return retval Else Return Null
	EndMethod
	
	Method MeshCreateFromMemory:MESH(x_file_ptr:Byte Ptr,x_memsize:Int,img_file_ptr:Byte Ptr,img_memsize:Int,texture_id:Int,generateFunc:Byte Ptr=Null)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return Null
		EndIf	
		Local retval:MESH
		If generateFunc<>Null
			Local genFunc:MESH()=generateFunc
			retval=genFunc()
		Else
			retval=_g_3IEngine.generateMesh()
		EndIf
		retval.objptr=_iBodyMeshCreateFromMemory(x_file_ptr,x_memsize,img_file_ptr,img_memsize,texture_id,objptr)
		If retval.objptr<>Null Then Return retval Else Return Null
	EndMethod

	' new in v4.1.0	
	Method MeshPartCreate:MESH(x_filename:String,mapped_with_texture:Int,generateFunc:Byte Ptr=Null)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return Null
		EndIf	
		Local retval:MESH
		If generateFunc<>Null
			Local genFunc:MESH()=generateFunc
			retval=genFunc()
		Else
			retval=_g_3IEngine.generateMesh()
		EndIf
		retval.objptr=_iBodyMeshPartCreate(x_filename,mapped_with_texture,objptr)
		If retval.objptr<>Null Then Return retval Else Return Null
	EndMethod
	
	' new in v4.1.0
	Method MeshPartCreateFromMemory:MESH(x_file_ptr:Byte Ptr,x_memsize:Int,img_file_ptr:Byte Ptr,img_memsize:Int,texture_id:Int,mapped_with_texture:Int,generateFunc:Byte Ptr=Null)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return Null
		EndIf	
		Local retval:MESH
		If generateFunc<>Null
			Local genFunc:MESH()=generateFunc
			retval=genFunc()
		Else
			retval=_g_3IEngine.generateMesh()
		EndIf
		retval.objptr=_iBodyMeshPartCreateFromMemory(x_file_ptr,x_memsize,img_file_ptr,img_memsize,texture_id,mapped_with_texture,objptr)
		If retval.objptr<>Null Then Return retval Else Return Null
	EndMethod

	Method SkinMeshCreate:SKINMESH(x_filename:String,shader_filename:String,generateFunc:Byte Ptr=Null)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return Null
		EndIf	
		Local retval:SKINMESH
		If generateFunc<>Null
			Local genFunc:SKINMESH()=generateFunc
			retval=genFunc()
		Else
			retval=_g_3IEngine.generateSkinMesh()
		EndIf
		Local shader:Byte Ptr = Null
		If shader_filename Then shader = shader_filename.ToCString()		
		retval.objptr=_iBodySkinMeshCreate(x_filename,shader,objptr)
		MemFree(shader)
		If retval.objptr<>Null Then Return retval Else Return Null
	EndMethod
	
	Method SkinMeshCreateFromMemory:SKINMESH(x_file_ptr:Byte Ptr,x_memsize:Int,textures:Byte Ptr[],texture_sizes:Int[],shader_filename:String,generateFunc:Byte Ptr=Null)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return Null
		EndIf	
		Local retval:SKINMESH
		If generateFunc<>Null
			Local genFunc:SKINMESH()=generateFunc
			retval=genFunc()
		Else
			retval=_g_3IEngine.generateSkinMesh()
		EndIf
		Local shader:Byte Ptr = Null
		If shader_filename Then shader = shader_filename.ToCString()		
		retval.objptr=_iBodySkinMeshCreateFromMemory(x_file_ptr,x_memsize,Varptr(textures[0]),Varptr(texture_sizes[0]),shader,objptr)
		MemFree(shader)
		If retval.objptr<>Null Then Return retval Else Return Null
	EndMethod
	
	Method MeshBumpCreate:MESH(x_filename:String,bumpmap_texture_filename:String,bConvertToNormalMap:Int,generateFunc:Byte Ptr=Null)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return Null
		EndIf	
		Local retval:MESH
		If generateFunc<>Null
			Local genFunc:MESH()=generateFunc
			retval=genFunc()
		Else
			retval=_g_3IEngine.generateMesh()
		EndIf
		retval.objptr=_iBodyMeshBumpCreate(x_filename,bumpmap_texture_filename,bConvertToNormalMap,objptr)
		If retval.objptr<>Null Then Return retval Else Return Null
	EndMethod
	
	Method MeshBumpCreateFromMemory:MESH(x_file_ptr:Byte Ptr,x_memsize:Int,texture_file_ptr:Byte Ptr,texture_memsize:Int,texture_id:Int,bumpmap_texture_ptr:Byte Ptr,bumpmap_texture_memsize:Int,bumpmap_id:Int,bConvertToNormalMap:Int,generateFunc:Byte Ptr=Null) 
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return Null
		EndIf	
		Local retval:MESH
		If generateFunc<>Null
			Local genFunc:MESH()=generateFunc
			retval=genFunc()
		Else
			retval=_g_3IEngine.generateMesh()
		EndIf
		retval.objptr=_iBodyMeshBumpCreateFromMemory(x_file_ptr,x_memsize,texture_file_ptr,texture_memsize,texture_id,bumpmap_texture_ptr,bumpmap_texture_memsize,bumpmap_id,bConvertToNormalMap,objptr)
		If retval.objptr<>Null Then Return retval Else Return Null
	EndMethod

	Method MassSet(total_mass:Float)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyMassSet(objptr,total_mass)
	EndMethod
	
	Method EulerOrientationSet(firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder:String,bResetPreviousMemorizedOrientation:Int)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyEulerOrientationSet(objptr,firstRotation,secondRotation,thirdRotation,rotationOrder,bResetPreviousMemorizedOrientation)
	EndMethod
	
	Method OrientationSet(orientation:D3DXQUATERNION,bResetPreviousMemorizedOrientation:Int)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyOrientationSet(objptr,orientation.param(),bResetPreviousMemorizedOrientation)
	EndMethod
	
	Method OrientationSeek:Float(orientation:D3DXQUATERNION,intensity:Float)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return 0
		EndIf	
		Return _iBodyOrientationSeek(objptr,orientation.param(),intensity)
	EndMethod
	
	Method Orientation:D3DXQUATERNION(orientation:D3DXQUATERNION)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyOrientation(objptr,orientation.param())
		Return orientation
	EndMethod

	Method Yaw:Float()
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		Return _iBodyYaw(objptr)
	EndMethod
	
	Method Pitch:Float()
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		Return _iBodyPitch(objptr)
	EndMethod
	
	Method Roll:Float()
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		Return _iBodyRoll(objptr)
	EndMethod
	
	Method EulerOrientationAdd(firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder:String,bResetPreviousMemorizedOrientation:Int)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyEulerOrientationAdd(objptr,firstRotation,secondRotation,thirdRotation,rotationOrder,bResetPreviousMemorizedOrientation)
	EndMethod
	
	Method OrientationAdd(rotation:D3DXQUATERNION,bResetPreviousMemorizedOrientation:Int)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyOrientationAdd(objptr,rotation.param(),bResetPreviousMemorizedOrientation)
	EndMethod

	Method LocationSet(location:D3DXVECTOR3,bResetPreviousMemorizedLocation:Int)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyLocationSet(objptr,location.param(),bResetPreviousMemorizedLocation)
	EndMethod
	
	Method Location:D3DXVECTOR3(location:D3DXVECTOR3)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyLocation(objptr,location.param())
		Return location
	EndMethod
	
	Method PreviousLocation:D3DXVECTOR3(prevLocation:D3DXVECTOR3)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyPreviousLocation(objptr,prevLocation.param())
		Return prevLocation
	EndMethod
	
	Method LocationCMSet(location:D3DXVECTOR3,bResetPreviousMemorizedLocation:Int)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyLocationCMSet(objptr,location.param(),bResetPreviousMemorizedLocation)
	EndMethod
	
	Method LocationCM:D3DXVECTOR3(location:D3DXVECTOR3)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyLocationCM(objptr,location.param())
		Return location
	EndMethod
	
	Method LocationAdd(location:D3DXVECTOR3,bResetPreviousMemorizedLocation:Int)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyLocationAdd(objptr,location.param(),bResetPreviousMemorizedLocation)
	EndMethod

	Method CMOffset:D3DXVECTOR3(offset:D3DXVECTOR3)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyCMOffset(objptr,offset.param())
		Return offset
	EndMethod
	
	Method SpinSet(spin:D3DXVECTOR3)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodySpinSet(objptr,spin.param())
	EndMethod
	
	Method Spin(spin:D3DXVECTOR3)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodySpin(objptr,spin.param())
	EndMethod
	
	Method VelocitySet(velocity:D3DXVECTOR3)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyVelocitySet(objptr,velocity.param())
	EndMethod
	
	Method Velocity(velocity:D3DXVECTOR3)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyVelocity(objptr,velocity.param())
	EndMethod
	
	Method Kmh:Float()
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		Return _iBodyKmh(objptr)
	EndMethod
	
	Method PointVelocity(bodyPoint:D3DXVECTOR3,velocity:D3DXVECTOR3)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyPointVelocity(objptr,bodyPoint.param(),velocity.param())
	EndMethod

	Method DampingSet(maxSpeed:Float,linearFactor:Float,maxSpin:Float,angularFactor:Float)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyDampingSet(objptr,maxSpeed,linearFactor,maxSpin,angularFactor)
	EndMethod
	
	Method Damping2Set(maxSpeed:Float,linearFactor:Float,maxSpin:Float,angularFactor:Float)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyDamping2Set(objptr,maxSpeed,linearFactor,maxSpin,angularFactor)
	EndMethod
	
	Method DirectionalAngularDampingSet(maxSpin:Float,angularFactorX:Float,angularFactorY:Float,angularFactorZ:Float)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyDirectionalAngularDampingSet(objptr,maxSpin,angularFactorX,angularFactorY,angularFactorZ)
	EndMethod
	
	Method DirectionalLinearDampingSet(maxSpeed:Float,linearFactorX:Float,linearFactorY:Float,linearFactorZ:Float)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyDirectionalLinearDampingSet(objptr,maxSpeed,linearFactorX,linearFactorY,linearFactorZ)
	EndMethod
	
	Method TorqueApply(torque:D3DXVECTOR3)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyTorqueApply(objptr,torque.param())
	EndMethod
	
	Method AngularAccelerationApply(angularAcceleration:D3DXVECTOR3)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyAngularAccelerationApply(objptr,angularAcceleration.param())
	EndMethod
	
	Method ForceApply(force:D3DXVECTOR3,forcePoint:D3DXVECTOR3)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		Local param:Byte Ptr=Null
		If forcepoint<>Null Then param=forcePoint.param()
		_iBodyForceApply(objptr,force.param(),param)
	EndMethod
	
	Method AccelerationApply(acceleration:D3DXVECTOR3)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyAccelerationApply(objptr,acceleration.param())
	EndMethod

	Method PhysicsReset()
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		_iBodyPhysicsReset(objptr)
	EndMethod
	
	Method SphereCount:Int()
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		Return _iBodySphereCount(objptr)
	EndMethod
	
	Method Sphere:SUBPART(subpart_idx:Int)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		Local retval:SUBPART=_g_3IEngine.generateSubPart()
		retval.objptr=_iBodySphere(objptr,subpart_idx)
		If retval.objptr<>Null Then Return retval Else Return Null
	EndMethod

	Method Scan:Int(origin:D3DXVECTOR3,direction:D3DXVECTOR3,radius:Float,contactPoint:D3DXVECTOR3,contactNormal:D3DXVECTOR3)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		Return _iBodyScan(objptr,origin.param(),direction.param(),radius,contactPoint.param(),contactNormal.param())
	EndMethod
	
	Method EnteringMesh:Int(referencePoint:D3DXVECTOR3,meshToCheck:MESH)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		Return _iBodyEnteringMesh(objptr,referencePoint.param(),meshToCheck.objptr)
	EndMethod
	
	Method ExitingMesh:Int(referencePoint:D3DXVECTOR3,meshToCheck:MESH)
		If Not IsValid()
			DebugLog("Invalid BODY")
			Return
		EndIf	
		Return _iBodyExitingMesh(objptr,referencePoint.param(),meshToCheck.objptr)
	EndMethod

	Method SurfaceStickinessSet(stickiness_factor:Float)
		_iBodySurfaceStickinessSet(objptr,stickiness_factor)
	EndMethod

	Method MassModelSet(x_filename:String,total_mass:Float)
		_iBodyMassModelSet(objptr,x_filename,total_mass)
	EndMethod
										
	Method SurfaceDriveSet(surface_drive:Float=0.0)
		_iBodySurfaceDriveSet(objptr,surface_drive)
	EndMethod
EndType

Function iBodyCreate:BODY(ply_filename:String,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.BodyCreate(ply_filename,generateFunc)
EndFunction

Function iBodyCreateFromMemory:BODY(ply_file_ptr:Byte Ptr,ply_memsize:Int,pol_file_ptr:Byte Ptr,pol_memsize:Int,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.BodyCreateFromMemory(ply_file_ptr,ply_memsize,pol_file_ptr,pol_memsize,generateFunc)
EndFunction

Function iBodySGCreate:BODY(spg_filename:String,total_mass:Float,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.BodySGCreate(spg_filename,total_mass,generateFunc)
EndFunction

Function iBodySGCreateFromMemory:BODY(spg_file_ptr:Byte Ptr,spg_memsize:Int,total_mass:Float,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.BodySGCreateFromMemory(spg_file_ptr,spg_memsize,total_mass,generateFunc)
EndFunction

Function iBodySphereCreate:BODY(radius:Float,offset:D3DXVECTOR3,total_mass:Float,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.BodySphereCreate(radius,offset,total_mass,generateFunc)
EndFunction

Function iBodyDestroy(bdy:BODY)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.Destroy()
EndFunction

Function iBodyDisable(bdy:BODY)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.Disable()
EndFunction

Function iBodyEnable(bdy:BODY)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.Enable()
EndFunction

Function iBodyStatus:Int(bdy:BODY)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.Status()
EndFunction

Function iBodyMeshCreate:MESH(x_filename:String,bdy:BODY,generateFunc:Byte Ptr=Null)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.MeshCreate(x_filename,generateFunc)
EndFunction

Function iBodyMeshCreateFromMemory:MESH(x_file_ptr:Byte Ptr,x_memsize:Int,img_file_ptr:Byte Ptr,img_memsize:Int,texture_id:Int,bdy:BODY,generateFunc:Byte Ptr=Null)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.MeshCreateFromMemory(x_file_ptr,x_memsize,img_file_ptr,img_memsize,texture_id,generateFunc)
EndFunction

Function iBodySkinMeshCreate:SKINMESH(x_filename:String,shader_filename:String,bdy:BODY,generateFunc:Byte Ptr=Null)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.SkinMeshCreate(x_filename,shader_filename,generateFunc)
EndFunction

Function iBodySkinMeshCreateFromMemory:SKINMESH(x_file_ptr:Byte Ptr,x_memsize:Int,textures:Byte Ptr[],texture_sizes:Int[],shader_filename:String,bdy:BODY,generateFunc:Byte Ptr=Null)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.SkinMeshCreateFromMemory(x_file_ptr,x_memsize,textures,texture_sizes,shader_filename,generateFunc)
EndFunction

Function iBodyMeshBumpCreate:MESH(x_filename:String,bumpmap_texture_filename:String,bConvertToNormalMap:Int,bdy:BODY,generateFunc:Byte Ptr=Null)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.MeshBumpCreate(x_filename,bumpmap_texture_filename,bConvertToNormalMap,generateFunc)
EndFunction

Function iBodyMeshBumpCreateFromMemory:MESH(x_file_ptr:Byte Ptr,x_memsize:Int,texture_file_ptr:Byte Ptr,texture_memsize:Int,texture_id:Int,bumpmap_texture_ptr:Byte Ptr,bumpmap_texture_memsize:Int,bumpmap_id:Int,bConvertToNormalMap:Int,bdy:BODY,generateFunc:Byte Ptr=Null)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.MeshBumpCreateFromMemory(x_file_ptr,x_memsize,texture_file_ptr,texture_memsize,texture_id,bumpmap_texture_ptr,bumpmap_texture_memsize,bumpmap_id,bConvertToNormalMap,generateFunc)
EndFunction

Function iBodyMassSet(bdy:BODY,total_mass:Float)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.MassSet(total_mass)
EndFunction

Function iBodyEulerOrientationSet(bdy:BODY,firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder:String,bResetPreviousMemorizedOrientation:Int)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.EulerOrientationSet(firstRotation,secondRotation,thirdRotation,rotationOrder,bResetPreviousMemorizedOrientation)
EndFunction

Function iBodyOrientationSet(bdy:BODY,orientation:D3DXQUATERNION,bResetPreviousMemorizedOrientation:Int)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.OrientationSet(orientation,bResetPreviousMemorizedOrientation)
EndFunction

Function iBodyOrientationSeek:Float(bdy:BODY,orientation:D3DXQUATERNION,intensity:Float)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.OrientationSeek(orientation,intensity)
EndFunction

Function iBodyOrientation:D3DXQUATERNION(bdy:BODY,orientation:D3DXQUATERNION)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.Orientation(orientation)
	Return orientation
EndFunction

Function iBodyYaw:Float(bdy:BODY)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.Yaw()
EndFunction

Function iBodyPitch:Float(bdy:BODY)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.Pitch()
EndFunction

Function iBodyRoll:Float(bdy:BODY)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.Roll()
EndFunction

Function iBodyEulerOrientationAdd(bdy:BODY,firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder:String,bResetPreviousMemorizedOrientation:Int)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.EulerOrientationAdd(firstRotation,secondRotation,thirdRotation,rotationOrder,bResetPreviousMemorizedOrientation)
EndFunction

Function iBodyOrientationAdd(bdy:BODY,rotation:D3DXQUATERNION,bResetPreviousMemorizedOrientation:Int)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.OrientationAdd(rotation,bResetPreviousMemorizedOrientation)
EndFunction

Function iBodyLocationSet(bdy:BODY,location:D3DXVECTOR3,bResetPreviousMemorizedLocation:Int)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.LocationSet(location,bResetPreviousMemorizedLocation)
EndFunction

Function iBodyLocation:D3DXVECTOR3(bdy:BODY,location:D3DXVECTOR3)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.Location(location)
	Return location
EndFunction

Function iBodyPreviousLocation:D3DXVECTOR3(bdy:BODY,prevLocation:D3DXVECTOR3)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.PreviousLocation(prevLocation)
	Return prevLocation
EndFunction

Function iBodyLocationCMSet(bdy:BODY,location:D3DXVECTOR3,bResetPreviousMemorizedLocation:Int)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.LocationCMSet(location,bResetPreviousMemorizedLocation)
EndFunction

Function iBodyLocationCM:D3DXVECTOR3(bdy:BODY,location:D3DXVECTOR3)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.LocationCM(location)
	Return location
EndFunction

Function iBodyLocationAdd(bdy:BODY,location:D3DXVECTOR3,bResetPreviousMemorizedLocation:Int)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.LocationAdd(location,bResetPreviousMemorizedLocation)
EndFunction

Function iBodyCMOffset:D3DXVECTOR3(bdy:BODY,offset:D3DXVECTOR3)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.CMOffset(offset)
	Return offset
EndFunction

Function iBodySpinSet(bdy:BODY,spin:D3DXVECTOR3)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.SpinSet(spin)
EndFunction

Function iBodySpin(bdy:BODY,spin:D3DXVECTOR3)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.Spin(spin)
EndFunction

Function iBodyVelocitySet(bdy:BODY,velocity:D3DXVECTOR3)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.VelocitySet(velocity)
EndFunction

Function iBodyVelocity(bdy:BODY,velocity:D3DXVECTOR3)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.Velocity(velocity)
EndFunction

Function iBodyKmh:Float(bdy:BODY)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.Kmh()
EndFunction

Function iBodyPointVelocity(bdy:BODY,bodyPoint:D3DXVECTOR3,velocity:D3DXVECTOR3)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.PointVelocity(bodyPoint,velocity)
EndFunction

Function iBodyDampingSet(bdy:BODY,maxSpeed:Float,linearFactor:Float,maxSpin:Float,angularFactor:Float)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.DampingSet(maxSpeed,linearFactor,maxSpin,angularFactor)
EndFunction

Function iBodyDamping2Set(bdy:BODY,maxSpeed:Float,linearFactor:Float,maxSpin:Float,angularFactor:Float)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.Damping2Set(maxSpeed,linearFactor,maxSpin,angularFactor)
EndFunction

Function iBodyDirectionalAngularDampingSet(bdy:BODY,maxSpin:Float,angularFactorX:Float,angularFactorY:Float,angularFactorZ:Float)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.DirectionalAngularDampingSet(maxSpin,angularFactorX,angularFactorY,angularFactorZ)
EndFunction

Function iBodyDirectionalLinearDampingSet(bdy:BODY,maxSpeed:Float,linearFactorX:Float,linearFactorY:Float,linearFactorZ:Float)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.DirectionalLinearDampingSet(maxSpeed,linearFactorX,linearFactorY,linearFactorZ)
EndFunction

Function iBodyTorqueApply(bdy:BODY,torque:D3DXVECTOR3)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.TorqueApply(torque)
EndFunction

Function iBodyAngularAccelerationApply(bdy:BODY,angularAcceleration:D3DXVECTOR3)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.AngularAccelerationApply(angularAcceleration)
EndFunction

Function iBodyForceApply(bdy:BODY,force:D3DXVECTOR3,forcePoint:D3DXVECTOR3)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.ForceApply(force,forcePoint)
EndFunction

Function iBodyAccelerationApply(bdy:BODY,acceleration:D3DXVECTOR3)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.AccelerationApply(acceleration)
EndFunction

Function iBodyPhysicsReset(bdy:BODY)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	bdy.PhysicsReset()
EndFunction

Function iBodySphereCount:Int(bdy:BODY)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.SphereCount()
EndFunction

Function iBodySphere:SUBPART(bdy:BODY,subpart_idx:Int)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.Sphere(subpart_idx)
EndFunction

Function iBodySphereCenter(part:SUBPART,sphereCenter:D3DXVECTOR3)
	If Not part
		DebugLog("SUBPART is Null")
		Return
	EndIf
	part.Center(sphereCenter)
EndFunction

Function iBodySphereRadius:Float(part:SUBPART)
	If Not part
		DebugLog("SUBPART is Null")
		Return
	EndIf
	Return part.Radius()
EndFunction

Function iBodyScan:Int(bdy:BODY,origin:D3DXVECTOR3,direction:D3DXVECTOR3,radius:Float,contactPoint:D3DXVECTOR3,contactNormal:D3DXVECTOR3)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.Scan(origin,direction,radius,contactPoint,contactNormal)
EndFunction

Function iBodyEnteringMesh:Int(bdy:BODY,referencePoint:D3DXVECTOR3,meshToCheck:MESH)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.EnteringMesh(referencePoint,meshToCheck)
EndFunction

Function iBodyExitingMesh:Int(bdy:BODY,referencePoint:D3DXVECTOR3,meshToCheck:MESH)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.ExitingMesh(referencePoint,meshToCheck)
EndFunction

' new in v4.1.0
Function iBodyMeshPartCreate:MESH(x_filename:String,mapped_with_texture:Int,bdy:BODY,generateFunc:Byte Ptr=Null)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.MeshPartCreate(x_filename,mapped_with_texture,generateFunc)
EndFunction

' new in v4.1.0
Function iBodyMeshPartCreateFromMemory:MESH(x_file_ptr:Byte Ptr,x_memsize:Int,img_file_ptr:Byte Ptr,img_memsize:Int,texture_id:Int,mapped_with_texture:Int,bdy:BODY,generateFunc:Byte Ptr=Null)
	If Not bdy
		DebugLog("BODY is Null")
		Return
	EndIf
	Return bdy.MeshPartCreateFromMemory(x_file_ptr,x_memsize,img_file_ptr,img_memsize,texture_id,mapped_with_texture,generateFunc)
EndFunction

Function iBodySurfaceStickinessSet(bdy:BODY,stickiness_factor:Float)
	bdy.SurfaceStickinessSet(stickiness_factor)
EndFunction

Function iBodyMassModelSet(bdy:BODY,x_filename:String,total_mass:Float)
	bdy.MassModelSet(x_filename,total_mass)
EndFunction

Function iBodySurfaceDriveSet(bdy:BODY,surface_drive:Float=0.0)
	bdy.SurfaceDriveSet(surface_drive)
EndFunction

Type SUBPART Extends i3ImpactBase

	Method Center(sphereCenter:D3DXVECTOR3)
		If Not IsValid() RuntimeError "Invalid SUBPART"
		_iBodySphereCenter(objptr,sphereCenter.param())
	EndMethod
	
	Method Radius:Float()
		If Not IsValid() RuntimeError "Invalid SUBPART"
		Return _iBodySphereRadius(objptr)
	EndMethod
	
EndType

Extern

	' BODY
	Function _iBodyCreate:Byte Ptr(ply_filename$z)="iBodyCreate" ' returns BODY* 
	Function _iBodyCreateFromMemory:Byte Ptr(ply_file_ptr:Byte Ptr,ply_memsize:Int,pol_file_ptr:Byte Ptr,pol_memsize:Int)="iBodyCreateFromMemory" ' returns BODY* 
	Function _iBodySGCreate:Byte Ptr(spg_filename$z,total_mass:Float)="iBodySGCreate" ' returns BODY*
	Function _iBodySGCreateFromMemory:Byte Ptr(spg_file_ptr:Byte Ptr,spg_memsize:Int,total_mass:Float)="iBodySGCreateFromMemory" ' returns BODY*
	Function _iBodySphereCreate:Byte Ptr(radius:Float,D3DXVECTOR3_offset:Byte Ptr,total_mass:Float)="iBodySphereCreate" ' returns BODY*
	Function _iBodyDestroy(BODY:Byte Ptr)="iBodyDestroy"
	Function _iBodyDisable(BODY:Byte Ptr)="iBodyDisable"
	Function _iBodyEnable(BODY:Byte Ptr)="iBodyEnable"
	Function _iBodyStatus:Int(BODY:Byte Ptr)="iBodyStatus" ' returns true/false
	Function _iBodyMeshCreate:Byte Ptr(x_filename$z,BODY:Byte Ptr)="iBodyMeshCreate" ' returns MESH* 
	Function _iBodyMeshCreateFromMemory:Byte Ptr(x_file_ptr:Byte Ptr,x_memsize:Int,img_file_ptr:Byte Ptr,img_memsize:Int,texture_id:Int,BODY:Byte Ptr)="iBodyMeshCreateFromMemory" ' returns MESH* 
	Function _iBodySkinMeshCreate:Byte Ptr(x_filename$z,shader_filename:Byte Ptr,BODY:Byte Ptr)="iBodySkinMeshCreate" ' returns SKINMESH* 
	Function _iBodySkinMeshCreateFromMemory:Byte Ptr(x_file_ptr:Byte Ptr,x_memsize:Int,texture_array:Byte Ptr Ptr,texture_size_array:Int Ptr,shader_filename:Byte Ptr,BODY:Byte Ptr)="iBodySkinMeshCreateFromMemory" ' returns SKINMESH* 
	Function _iBodyMeshBumpCreate:Byte Ptr(x_filename$z,bumpmap_texture_filename$z,bConvertToNormalMap:Int,BODY:Byte Ptr)="iBodyMeshBumpCreate" ' returns MESH* 
	Function _iBodyMeshBumpCreateFromMemory:Byte Ptr(x_file_ptr:Byte Ptr,x_memsize:Int,texture_file_ptr:Byte Ptr,texture_memsize:Int,texture_id:Int,bumpmap_texture_ptr:Byte Ptr,bumpmap_texture_memsize:Int,bumpmap_id:Int,bConvertToNormalMap:Int,BODY:Byte Ptr)="iBodyMeshBumpCreateFromMemory" ' returns MESH* 
	Function _iBodyMassSet(BODY:Byte Ptr,total_mass:Float)="iBodyMassSet"
	Function _iBodyEulerOrientationSet(BODY:Byte Ptr,firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder$z,bResetPreviousMemorizedOrientation:Int)="iBodyEulerOrientationSet"
	Function _iBodyOrientationSet(BODY:Byte Ptr,D3DXQUATERNION_orientation:Byte Ptr,bResetPreviousMemorizedOrientation:Int)="iBodyOrientationSet"
	Function _iBodyOrientationSeek:Float(BODY:Byte Ptr,D3DXQUATERNION_orientation:Byte Ptr,intensity:Float)="iBodyOrientationSeek"
	Function _iBodyOrientation:Byte Ptr(BODY:Byte Ptr,D3DXQUATERNION_orientation:Byte Ptr)="iBodyOrientation" ' returns D3DXQUATERNION* 
	Function _iBodyYaw:Float(BODY:Byte Ptr)="iBodyYaw"
	Function _iBodyPitch:Float(BODY:Byte Ptr)="iBodyPitch"
	Function _iBodyRoll:Float(BODY:Byte Ptr)="iBodyRoll"
	Function _iBodyEulerOrientationAdd(BODY:Byte Ptr,firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder$z,bResetPreviousMemorizedOrientation:Int)="iBodyEulerOrientationAdd"
	Function _iBodyOrientationAdd(BODY:Byte Ptr,D3DXQUATERNION_rotation:Byte Ptr,bResetPreviousMemorizedOrientation:Int)="iBodyOrientationAdd"
	Function _iBodyLocationSet(BODY:Byte Ptr,D3DXVECTOR3_location:Byte Ptr,bResetPreviousMemorizedLocation:Int)="iBodyLocationSet"
	Function _iBodyLocation:Byte Ptr(BODY:Byte Ptr,D3DXVECTOR3_location:Byte Ptr)="iBodyLocation" ' returns D3DXVECTOR3* 
	Function _iBodyPreviousLocation:Byte Ptr(BODY:Byte Ptr,D3DXVECTOR3_prevLocation:Byte Ptr)="iBodyPreviousLocation" ' returns D3DXVECTOR3* 
	Function _iBodyLocationCMSet(BODY:Byte Ptr,D3DXVECTOR3_location:Byte Ptr,bResetPreviousMemorizedLocation:Int)="iBodyLocationCMSet"
	Function _iBodyLocationCM:Byte Ptr(BODY:Byte Ptr,D3DXVECTOR3_location:Byte Ptr)="iBodyLocationCM" ' returns D3DXVECTOR3* 
	Function _iBodyLocationAdd(BODY:Byte Ptr,D3DXVECTOR3_location:Byte Ptr,bResetPreviousMemorizedLocation:Int)="iBodyLocationAdd"
	Function _iBodyCMOffset:Byte Ptr(BODY:Byte Ptr,D3DXVECTOR3_offset:Byte Ptr)="iBodyCMOffset" ' returns D3DXVECTOR3* 
	Function _iBodySpinSet(BODY:Byte Ptr,D3DXVECTOR3_spin:Byte Ptr)="iBodySpinSet"
	Function _iBodySpin(BODY:Byte Ptr,D3DXVECTOR3_spin:Byte Ptr)="iBodySpin"
	Function _iBodyVelocitySet(BODY:Byte Ptr,D3DXVECTOR3_velocity:Byte Ptr)="iBodyVelocitySet"
	Function _iBodyVelocity(BODY:Byte Ptr,D3DXVECTOR3_velocity:Byte Ptr)="iBodyVelocity"
	Function _iBodyKmh:Float(BODY:Byte Ptr)="iBodyKmh"
	Function _iBodyPointVelocity(BODY:Byte Ptr,D3DXVECTOR3_bodyPoint:Byte Ptr,D3DXVECTOR3_velocity:Byte Ptr)="iBodyPointVelocity"
	Function _iBodyDampingSet(BODY:Byte Ptr,maxSpeed:Float,linearFactor:Float,maxSpin:Float,angularFactor:Float)="iBodyDampingSet"
	Function _iBodyDamping2Set(BODY:Byte Ptr,maxSpeed:Float,linearFactor:Float,maxSpin:Float,angularFactor:Float)="iBodyDamping2Set"
	Function _iBodyDirectionalAngularDampingSet(BODY:Byte Ptr,maxSpin:Float,angularFactorX:Float,angularFactorY:Float,angularFactorZ:Float)="iBodyDirectionalAngularDampingSet"
	Function _iBodyDirectionalLinearDampingSet(BODY:Byte Ptr,maxSpeed:Float,linearFactorX:Float,linearFactorY:Float,linearFactorZ:Float)="iBodyDirectionalLinearDampingSet"
	Function _iBodyTorqueApply(BODY:Byte Ptr,D3DXVECTOR3_torque:Byte Ptr)="iBodyTorqueApply"
	Function _iBodyAngularAccelerationApply(BODY:Byte Ptr,D3DXVECTOR3_angularAcceleration:Byte Ptr)="iBodyAngularAccelerationApply"
	Function _iBodyForceApply(BODY:Byte Ptr,D3DXVECTOR3_force:Byte Ptr,D3DXVECTOR3_forcePoint:Byte Ptr)="iBodyForceApply"
	Function _iBodyAccelerationApply(BODY:Byte Ptr,D3DXVECTOR3_acceleration:Byte Ptr)="iBodyAccelerationApply"
	Function _iBodyPhysicsReset(BODY:Byte Ptr)="iBodyPhysicsReset"
	Function _iBodySphereCount:Int(BODY:Byte Ptr)="iBodySphereCount"
	Function _iBodySphere:Byte Ptr(BODY:Byte Ptr,subpart_idx:Int)="iBodySphere" ' returns SUBPART*
	Function _iBodySphereCenter(SUBPART:Byte Ptr,D3DXVECTOR3_sphereCenter:Byte Ptr)="iBodySphereCenter"
	Function _iBodySphereRadius:Float(SUBPART:Byte Ptr)="iBodySphereRadius"
	Function _iBodyScan:Int(BODY:Byte Ptr,D3DXVECTOR3_origin:Byte Ptr,D3DXVECTOR3_direction:Byte Ptr,radius:Float,D3DXVECTOR3_contactPoint:Byte Ptr,D3DXVECTOR3_contactNormal:Byte Ptr)="iBodyScan"
	Function _iBodyEnteringMesh:Int(BODY:Byte Ptr,D3DXVECTOR3_referencePoint:Byte Ptr,MESH:Byte Ptr)="iBodyEnteringMesh"
	Function _iBodyExitingMesh:Int(BODY:Byte Ptr,D3DXVECTOR3_referencePoint:Byte Ptr,MESH:Byte Ptr)="iBodyExitingMesh"

	' 2006/2/22 GG - new in v4.1.0
	Function _iBodyMeshPartCreate:Byte Ptr(x_filename$z,mapped_to_texture:Int,BODY:Byte Ptr)="iBodyMeshPartCreate" ' returns MESH*
	Function _iBodyMeshPartCreateFromMemory:Byte Ptr(x_file_ptr:Byte Ptr,x_memsize:Int,img_file_ptr:Byte Ptr,img_memsize:Int,texture_id:Int,mapped_to_texture:Int,BODY:Byte Ptr)="iBodyMeshPartCreateFromMemory" ' returns MESH*
	
	' new in v5.1.0
	Function _iBodySurfaceStickinessSet(BODY:Byte Ptr,stickiness_factor:Float)="iBodySurfaceStickinessSet"
	Function _iBodyMassModelSet(BODY:Byte Ptr,x_filename$z,total_mass:Float)="iBodyMassModelSet"
	Function _iBodySurfaceDriveSet(BODY:Byte Ptr,surface_drive:Float=0.0)="iBodySurfaceDriveSet"
EndExtern

