' 2006/02/22 GG - added new iMeshPartCreate() and iMeshPartCreateFromMemory() implemented in v4.1.0

' MESH
Type MESH Extends i3ImpactBase	

	Method Destroy()
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshDestroy(objptr)
		objptr=Null
	EndMethod 
	Method Hide()
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshHide(objptr)
	EndMethod 
	
	Method Show()
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshShow(objptr)
	EndMethod 
	
	Method EulerOrientationSet(firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder:String)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshEulerOrientationSet(objptr,firstRotation,secondRotation,thirdRotation,rotationOrder)
	EndMethod 
	
	Method OrientationSet(orientation:D3DXQUATERNION)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshOrientationSet(objptr,orientation.param())
	EndMethod 
	
	Method Orientation:D3DXQUATERNION(orientation:D3DXQUATERNION)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshOrientation(objptr,orientation.param())
		Return orientation
	EndMethod 
	
	Method OrientationAdd(rotation:D3DXVECTOR3,degreesAdd:Float)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshOrientationAdd(objptr,rotation.param(),degreesAdd)
	EndMethod 
	
	Method LocationSet(location:D3DXVECTOR3)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshLocationSet(objptr,location.param())
	EndMethod 
	
	Method Location:D3DXVECTOR3(location:D3DXVECTOR3)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshLocation(objptr,location.param())
		Return location
	EndMethod 
	
	Method ScaleSet(scaleX:Float,scaleY:Float,scaleZ:Float)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshScaleSet(objptr,scaleX,scaleY,scaleZ)
	EndMethod 
	
	Method RenderPrioritySet(priority:Int)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshRenderPrioritySet(objptr,priority)
	EndMethod 
	
	Method RenderModeSet(D3DRENDERSTATE_SRCBLEND_factor:Int,D3DRENDERSTATE_DESTBLEND_factor:Int,bUseZBuffer:Int,bRenderAfterShadows:Int=False)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshRenderModeSet(objptr,D3DRENDERSTATE_SRCBLEND_factor,D3DRENDERSTATE_DESTBLEND_factor,bUseZBuffer,bRenderAfterShadows)
	EndMethod 
	
	Method ZBiasSet(zBias:Int)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshZBiasSet(objptr,zBias)
	EndMethod 
	
	Method SpecularSet(factor:Float,power:Float)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshSpecularSet(objptr,factor,power)
	EndMethod 
	
	Method AlphaSet(alpha:Float)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshAlphaSet(objptr,alpha)
	EndMethod 
	
	Method EmissiveSet(red:Float,green:Float,blue:Float,alpha:Float)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshEmissiveSet(objptr,red,green,blue,alpha)
	EndMethod 
	
	Method FogSet(startDist:Float,endDist:Float)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshFogSet(objptr,startDist,endDist)
	EndMethod 
	
	Method WireframeEnable(bEnable:Int)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshWireframeEnable(objptr,bEnable)
	EndMethod 
	
	Method SecondaryTextureSet(texture_filename:String,centerOffset:D3DXVECTOR2,tileSize:Float,blend:Float)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshSecondaryTextureSet(objptr,texture_filename,centerOffset.param(),tileSize,blend)
	EndMethod 
	
	Method SecondaryTextureSetFast(centerOffset:D3DXVECTOR2,tileSize:Float,blend:Float)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshSecondaryTextureSetFast(objptr,centerOffset.param(),tileSize,blend)
	EndMethod 
	
	Method LocalLightsEnable(bEnable:Int)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshLocalLightsEnable(objptr,bEnable)
	EndMethod 
	
	Method BumpAmbientColorSet(red:Float,green:Float,blue:Float)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshBumpAmbientColorSet(objptr,red,green,blue)
	EndMethod 
	
	Method MirrorMake(bRenderAsMirror:Int)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshMirrorMake(objptr,bRenderAsMirror)
	EndMethod 
	
	Method Visible:Int(cam:CAMERA)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		Return _iMeshVisible(cam.objptr,objptr)
	EndMethod 
	
	Method Picked:Int(cam:CAMERA)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		Return _iMeshPicked(cam.objptr,objptr)
	EndMethod 
	
	Method RayCheck:Int(origin:D3DXVECTOR3,direction:D3DXVECTOR3)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		Return _iMeshRayCheck(objptr,origin.param(),direction.param())
	EndMethod 
	
	Method BoundingSphereRayCheck:Int(origin:D3DXVECTOR3,direction:D3DXVECTOR3)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		Return _iMeshBoundingSphereRayCheck(objptr,origin.param(),direction.param())
	EndMethod 
	
	Method StretchToSegment(center:D3DXVECTOR3,secondSeg:D3DXVECTOR3,upVector:D3DXVECTOR3,scale:Float)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshStretchToSegment(objptr,center.param(),secondSeg.param(),upVector.param(),scale)
	EndMethod 
	
	Method TextureSet(tex:TEXTURE)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshTextureSet(objptr,tex.objptr)
	EndMethod 
	
	Method TextureReset()
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshTextureReset(objptr)
	EndMethod 
		
	Method BumpTextureSet(bumptex:TEXTURE)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshBumpTextureSet(objptr,bumptex.objptr)
	EndMethod 
	
	Method BumpTextureReset()
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshBumpTextureReset(objptr)
	EndMethod 
	
	Method TextureSwap(tex:TEXTURE)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshTextureSwap(objptr,tex.objptr)
	EndMethod 
	
	Method BumpTextureSwap(bumptex:TEXTURE)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshBumpTextureSwap(objptr,bumptex.objptr)
	EndMethod 
	
	Method TextureChange(texture_filename:String)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshTextureChange(objptr,texture_filename)
	EndMethod 
	
	Method AlphaTextureChange(texture_filename:String)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshAlphaTextureChange(objptr,texture_filename)
	EndMethod 
	
	Method TexturePath(path:String)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshTexturePath(objptr,path)
	EndMethod 
	
	Method TextureModeSet(mapping_mode:Int)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshTextureModeSet(objptr,mapping_mode)
	EndMethod 
	
	Method TextureMipMapLodSet(LOD:Float)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshTextureMipMapLodSet(objptr,LOD)
	EndMethod
	
	Function TextureSharingSet(bShare:Int)
		_iMeshTextureSharingSet(bShare)
	EndFunction
	
	Function BuffersSharingSet(bShare:Int)
		_iMeshBuffersSharingSet(bShare)
	EndFunction
	
	Method EnvMapReceiverAdd(env:ENVMAP)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshEnvMapReceiverAdd(objptr,env.objptr)
	EndMethod 
	
	Method EnvMapBlendSet(visibility:Float)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshEnvMapBlendSet(objptr,visibility)
	EndMethod 
	
	Method EnvMapGlassSet(refractionFactor:Float)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshEnvMapGlassSet(objptr,refractionFactor)
	EndMethod 
	
	Method EnvMapCasterAdd()
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshEnvMapCasterAdd(objptr)
	EndMethod 
	
	Method EnvMapCasterRemove()
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshEnvMapCasterRemove(objptr)
	EndMethod 
	
	Method Transfer(bdy:BODY)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		If bdy=Null Then bdy=New BODY
		_iMeshTransfer(objptr,bdy.objptr)
	EndMethod 

	Method ShadowCasterExtrusionSet(extrusion:Float)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshShadowCasterExtrusionSet(objptr,extrusion)
	EndMethod
	
	Method ShadowCasterNormalsRecompute()
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshShadowCasterNormalsRecompute(objptr)
	EndMethod

	Method VertexBufferDynamicMake(bReadWrite:Int)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshVertexBufferDynamicMake(objptr,bReadWrite)
	EndMethod
	
	Method VertexBufferClose()
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshVertexBufferClose(objptr)
	EndMethod
	
	Method VertexBufferSize:Int()
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		Return _iMeshVertexBufferSize(objptr)
	EndMethod
	
	Method VertexBufferSizeSet(vertices:Int)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshVertexBufferSizeSet(objptr,vertices)
	EndMethod
	
	Method FaceBufferDynamicMake(bReadWrite:Int)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshFaceBufferDynamicMake(objptr,bReadWrite)
	EndMethod
	
	Method FaceBufferClose()
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshFaceBufferClose(objptr)
	EndMethod
	
	Method FaceBufferSize:Int()
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		Return _iMeshFaceBufferSize(objptr)
	EndMethod
	
	Method FaceBufferSizeSet(faces:Int)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		_iMeshFaceBufferSizeSet(objptr,faces)
	EndMethod

	Method VertexBufferOpen(verts:MESHVERTEXBUFFER Var)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
	 	If Not verts Then verts=_g_3IEngine.generateMeshVertexBuffer()
		_iMeshVertexBufferOpen(objptr,Varptr(verts._ptr))
	EndMethod 
	
	Method VertexBufferOriginal(verts:MESHVERTEXBUFFER Var)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
	 	If Not verts Then verts=_g_3IEngine.generateMeshVertexBuffer()
		_iMeshVertexBufferOriginal(objptr,Varptr(verts._ptr))
	EndMethod 
	
	Method FaceBufferOpen(faces:MESHFACEBUFFER Var)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		If Not faces Then faces=_g_3IEngine.generateMeshFaceBuffer()
		_iMeshFaceBufferOpen(objptr,Varptr(faces._ptr))
	EndMethod 
	
	Method FaceBufferOriginal(faces:MESHFACEBUFFER Var)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		If Not faces Then faces=_g_3IEngine.generateMeshFaceBuffer()
		_iMeshFaceBufferOriginal(objptr,Varptr(faces._ptr))
	EndMethod 

	Method BoundingSphere:Float(center:D3DXVECTOR3)
		If Not IsValid() 
			DebugLog("Invalid MESH")
			Return
		EndIf
		Return _iMeshBoundingSphere(objptr,center.param())
	EndMethod
			
EndType

Function iMeshCreate:MESH(x_filename:String,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.MeshCreate(x_filename,generateFunc)
EndFunction

Function iMeshCreateFromMemory:MESH(x_file_memptr:Byte Ptr,x_memsize:Int,texture_file_memptr:Byte Ptr,texture_memsize:Int,texture_id:Int,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.MeshCreateFromMemory(x_file_memptr,x_memsize,texture_file_memptr,texture_memsize,texture_id,generateFunc)
EndFunction

' new in v4.1.0
Function iMeshPartCreate:MESH(x_filename:String,mapped_with_texture:Int,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.MeshPartCreate(x_filename,mapped_with_texture,generateFunc)
EndFunction

' new in v4.1.0
Function iMeshPartCreateFromMemory:MESH(x_file_memptr:Byte Ptr,x_memsize:Int,texture_file_memptr:Byte Ptr,texture_memsize:Int,texture_id:Int,mapped_with_texture:Int,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.MeshPartCreateFromMemory(x_file_memptr,x_memsize,texture_file_memptr,texture_memsize,texture_id,mapped_with_texture,generateFunc)
EndFunction

Function iMeshBumpCreate:MESH(x_filename:String,texture_filename:String,bConvertToNormalMap:Int,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.MeshBumpCreate(x_filename,texture_filename,bConvertToNormalMap,generateFunc)
EndFunction

Function iMeshBumpCreateFromMemory:MESH(x_file_memptr:Byte Ptr,x_memsize:Int,texture_file_memptr:Byte Ptr,texture_memsize:Int,texture_id:Int,bumpmap_img_memptr:Byte Ptr,bumpmap_img_memsize:Int,bumpmap_id:Int,bConvertToNormalMap:Int,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.MeshBumpCreateFromMemory(x_file_memptr,x_memsize,texture_file_memptr,texture_memsize,texture_id,bumpmap_img_memptr,bumpmap_img_memsize,bumpmap_id,bConvertToNormalMap,generateFunc)
EndFunction

Function iMeshDestroy(msh:MESH)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.Destroy()
EndFunction

Function iMeshHide(msh:MESH)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.Hide()
EndFunction

Function iMeshShow(msh:MESH)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.Show()
EndFunction

Function iMeshEulerOrientationSet(msh:MESH,firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder:String)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.EulerOrientationSet(firstRotation,secondRotation,thirdRotation,rotationOrder)
EndFunction

Function iMeshOrientationSet(msh:MESH,orientation:D3DXQUATERNION)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.OrientationSet(orientation)
EndFunction

Function iMeshOrientation:D3DXQUATERNION(msh:MESH,orientation:D3DXQUATERNION)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	Return msh.Orientation(orientation)
EndFunction

Function iMeshOrientationAdd(msh:MESH,rotation:D3DXVECTOR3,degreesAdd:Float)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.OrientationAdd(rotation,degreesAdd)
EndFunction

Function iMeshLocationSet(msh:MESH,location:D3DXVECTOR3)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.LocationSet(location)
EndFunction

Function iMeshLocation:D3DXVECTOR3(msh:MESH,location:D3DXVECTOR3)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	Return msh.Location(location)
EndFunction

Function iMeshScaleSet(msh:MESH,scaleX:Float,scaleY:Float,scaleZ:Float)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.ScaleSet(scaleX,scaleY,scaleZ)
EndFunction

Function iMeshRenderPrioritySet(msh:MESH,priority:Int)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.RenderPrioritySet(priority)
EndFunction

Function iMeshRenderModeSet(msh:MESH,D3DRENDERSTATE_SRCBLEND_factor:Int,D3DRENDERSTATE_DESTBLEND_factor:Int,bUseZBuffer:Int,bRenderAfterShadows:Int=False)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.RenderModeSet(D3DRENDERSTATE_SRCBLEND_factor,D3DRENDERSTATE_DESTBLEND_factor,bUseZBuffer,bRenderAfterShadows)
EndFunction

Function iMeshZBiasSet(msh:MESH,zBias:Int)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.ZBiasSet(zBias)
EndFunction

Function iMeshSpecularSet(msh:MESH,factor:Float,power:Float)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.SpecularSet(factor,power)
EndFunction

Function iMeshAlphaSet(msh:MESH,alpha:Float)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.AlphaSet(alpha)
EndFunction

Function iMeshEmissiveSet(msh:MESH,red:Float,green:Float,blue:Float,alpha:Float)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.EmissiveSet(red,green,blue,alpha)
EndFunction

Function iMeshFogSet(msh:MESH,startDist:Float,endDist:Float)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.FogSet(startDist,endDist)
EndFunction

Function iMeshWireframeEnable(msh:MESH,bEnable:Int)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.WireframeEnable(bEnable)
EndFunction

Function iMeshSecondaryTextureSet(msh:MESH,texture_filename:String,centerOffset:D3DXVECTOR2,tileSize:Float,blend:Float)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.SecondaryTextureSet(texture_filename,centerOffset,tileSize,blend)
EndFunction

Function iMeshSecondaryTextureSetFast(msh:MESH,centerOffset:D3DXVECTOR2,tileSize:Float,blend:Float)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.SecondaryTextureSetFast(centerOffset,tileSize,blend)
EndFunction

Function iMeshLocalLightsEnable(msh:MESH,bEnable:Int)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.LocalLightsEnable(bEnable)
EndFunction

Function iMeshBumpAmbientColorSet(msh:MESH,red:Float,green:Float,blue:Float)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.BumpAmbientColorSet(red,green,blue)
EndFunction

Function iMeshMirrorMake(msh:MESH,bRenderAsMirror:Int)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.MirrorMake(bRenderAsMirror)
EndFunction

Function iMeshVisible:Int(cam:CAMERA,msh:MESH)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	Return msh.Visible(cam)
EndFunction

Function iMeshPicked:Int(cam:CAMERA,msh:MESH)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	Return msh.Picked(cam)
EndFunction

Function iMeshRayCheck:Int(msh:MESH,origin:D3DXVECTOR3,direction:D3DXVECTOR3)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	Return msh.RayCheck(origin,direction)
EndFunction

Function iMeshBoundingSphereRayCheck:Int(msh:MESH,origin:D3DXVECTOR3,direction:D3DXVECTOR3)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	Return msh.BoundingSphereRayCheck(origin,direction)
EndFunction

Function iMeshStretchToSegment(msh:MESH,center:D3DXVECTOR3,secondSeg:D3DXVECTOR3,upVector:D3DXVECTOR3,scale:Float)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.StretchToSegment(center,secondSeg,upVector,scale)
EndFunction

Function iMeshTextureSet(msh:MESH,tex:TEXTURE)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.TextureSet(tex)
EndFunction

Function iMeshTextureReset(msh:MESH)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.TextureReset()
EndFunction
	
Function iMeshBumpTextureSet(msh:MESH,bumptex:TEXTURE)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.BumpTextureSet(bumptex)
EndFunction

Function iMeshBumpTextureReset(msh:MESH)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.BumpTextureReset()
EndFunction

Function iMeshTextureSwap(msh:MESH,tex:TEXTURE)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.TextureSwap(tex)
EndFunction

Function iMeshBumpTextureSwap(msh:MESH,bumptex:TEXTURE)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.BumpTextureSwap(bumptex)
EndFunction

Function iMeshTextureChange(msh:MESH,texture_filename:String)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.TextureChange(texture_filename)
EndFunction

Function iMeshAlphaTextureChange(msh:MESH,texture_filename:String)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.AlphaTextureChange(texture_filename)
EndFunction

Function iMeshTexturePath(msh:MESH,path:String)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.TexturePath(path)
EndFunction

Function iMeshTextureModeSet(msh:MESH,mapping_mode:Int)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.TextureModeSet(mapping_mode)
EndFunction

Function iMeshTextureMipMapLodSet(msh:MESH,LOD:Float)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.TextureMipMapLodSet(LOD)
EndFunction

Function iMeshTextureSharingSet(bShare:Int)
	MESH.TextureSharingSet(bShare)
EndFunction

Function iMeshBuffersSharingSet(bShare:Int)
	MESH.BuffersSharingSet(bShare)
EndFunction

Function iMeshEnvMapReceiverAdd(msh:MESH,env:ENVMAP)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.EnvMapReceiverAdd(env)
EndFunction

Function iMeshEnvMapBlendSet(msh:MESH,visibility:Float)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.EnvMapBlendSet(visibility)
EndFunction

Function iMeshEnvMapGlassSet(msh:MESH,refractionFactor:Float)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.EnvMapGlassSet(refractionFactor)
EndFunction

Function iMeshEnvMapCasterAdd(msh:MESH)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.EnvMapCasterAdd()
EndFunction

Function iMeshEnvMapCasterRemove(msh:MESH)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.EnvMapCasterRemove()
EndFunction

Function iMeshTransfer(msh:MESH,bdy:BODY)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.Transfer(bdy)
EndFunction

Function iMeshShadowCasterExtrusionSet(msh:MESH,extrusion:Float)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.ShadowCasterExtrusionSet(extrusion)
EndFunction

Function iMeshShadowCasterNormalsRecompute(msh:MESH)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.ShadowCasterNormalsRecompute()
EndFunction

Function iMeshBoundingSphere:Float(msh:MESH,center:D3DXVECTOR3)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	Return msh.BoundingSphere(center)
EndFunction

Extern
	' MESH
	Function _iMeshCreate:Byte Ptr(x_filename$z)="iMeshCreate" ' returns MESH*
	Function _iMeshCreateFromMemory:Byte Ptr(x_file_memptr:Byte Ptr,x_memsize:Int,texture_file_memptr:Byte Ptr,texture_memsize:Int,texture_id:Int)="iMeshCreateFromMemory" ' returns MESH*
	Function _iMeshBumpCreate:Byte Ptr(x_filename$z,texture_filename$z,bConvertToNormalMap:Int)="iMeshBumpCreate"
	Function _iMeshBumpCreateFromMemory:Byte Ptr(x_file_memptr:Byte Ptr,x_memsize:Int,texture_file_memptr:Byte Ptr,texture_memsize:Int,texture_id:Int,bumpmap_img_memptr:Byte Ptr,bumpmap_img_memsize:Int,bumpmap_id:Int,bConvertToNormalMap:Int)="iMeshBumpCreateFromMemory" ' returns MESH* 
	Function _iMeshDestroy(MESH:Byte Ptr)="iMeshDestroy"
	Function _iMeshHide(MESH:Byte Ptr)="iMeshHide"
	Function _iMeshShow(MESH:Byte Ptr)="iMeshShow"
	Function _iMeshEulerOrientationSet(MESH:Byte Ptr,firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder$z)="iMeshEulerOrientationSet"
	Function _iMeshOrientationSet(MESH:Byte Ptr,D3DXQUATERNION_orientation:Byte Ptr)="iMeshOrientationSet"
	Function _iMeshOrientation:Byte Ptr(MESH:Byte Ptr,D3DXQUATERNION_orientation:Byte Ptr)="iMeshOrientation" ' returns D3DXQUATERNION* 
	Function _iMeshOrientationAdd(MESH:Byte Ptr,D3DXVECTOR3_rotation:Byte Ptr,degreesAdd:Float)="iMeshOrientationAdd"
	Function _iMeshLocationSet(MESH:Byte Ptr,D3DXVECTOR3_location:Byte Ptr)="iMeshLocationSet"
	Function _iMeshLocation:Byte Ptr(MESH:Byte Ptr,D3DXVECTOR3_location:Byte Ptr)="iMeshLocation" ' returns D3DXVECTOR3*
	Function _iMeshScaleSet(MESH:Byte Ptr,scaleX:Float,scaleY:Float,scaleZ:Float)="iMeshScaleSet"
	Function _iMeshRenderPrioritySet(MESH:Byte Ptr,priority:Int)="iMeshRenderPrioritySet"
	Function _iMeshRenderModeSet(MESH:Byte Ptr,D3DRENDERSTATE_SRCBLEND_factor:Int,D3DRENDERSTATE_DESTBLEND_factor:Int,bUseZBuffer:Int,bRenderAfterShadows:Int=False)="iMeshRenderModeSet"
	Function _iMeshZBiasSet(MESH:Byte Ptr,zBias:Int)="iMeshZBiasSet"
	Function _iMeshSpecularSet(MESH:Byte Ptr,factor:Float,power:Float)="iMeshSpecularSet"
	Function _iMeshAlphaSet(MESH:Byte Ptr,alpha:Float)="iMeshAlphaSet"
	Function _iMeshEmissiveSet(MESH:Byte Ptr,red:Float,green:Float,blue:Float,alpha:Float)="iMeshEmissiveSet"
	Function _iMeshFogSet(MESH:Byte Ptr,startDist:Float,endDist:Float)="iMeshFogSet"
	Function _iMeshWireframeEnable(MESH:Byte Ptr,bEnable:Int)="iMeshWireframeEnable"
	Function _iMeshSecondaryTextureSet(MESH:Byte Ptr,texture_filename$z,D3DXVECTOR2_centerOffset:Byte Ptr,tileSize:Float,blend:Float)="iMeshSecondaryTextureSet"
	Function _iMeshSecondaryTextureSetFast(MESH:Byte Ptr,D3DXVECTOR2_centerOffset:Byte Ptr,tileSize:Float,blend:Float)="iMeshSecondaryTextureSetFast"
	Function _iMeshLocalLightsEnable(MESH:Byte Ptr,bEnable:Int)="iMeshLocalLightsEnable"
	Function _iMeshBumpAmbientColorSet(MESH:Byte Ptr,red:Float,green:Float,blue:Float)="iMeshBumpAmbientColorSet"
	Function _iMeshMirrorMake(MESH:Byte Ptr,bRenderAsMirror:Int)="iMeshMirrorMake"
	Function _iMeshVisible:Int(CAMERA:Byte Ptr,MESH:Byte Ptr)="iMeshVisible" ' returns true/false
	Function _iMeshPicked:Int(CAMERA:Byte Ptr,MESH:Byte Ptr)="iMeshPicked" ' returns true/false
	Function _iMeshRayCheck:Int(MESH:Byte Ptr,D3DXVECTOR3_origin:Byte Ptr,D3DXVECTOR3_direction:Byte Ptr)="iMeshRayCheck" ' returns true/false
	Function _iMeshBoundingSphereRayCheck:Int(MESH:Byte Ptr,D3DXVECTOR3_origin:Byte Ptr,D3DXVECTOR3_direction:Byte Ptr)="iMeshBoundingSphereRayCheck" ' returns true/false
	Function _iMeshStretchToSegment(MESH:Byte Ptr,D3DXVECTOR3_center:Byte Ptr,D3DXVECTOR3_secondSeg:Byte Ptr,D3DXVECTOR3_upVector:Byte Ptr,scale:Float)="iMeshStretchToSegment"
	Function _iMeshTextureSet(MESH:Byte Ptr,TEXTURE:Byte Ptr)="iMeshTextureSet"
	Function _iMeshTextureReset(MESH:Byte Ptr)="iMeshTextureReset"
	Function _iMeshBumpTextureSet(MESH:Byte Ptr,TEXTURE:Byte Ptr)="iMeshBumpTextureSet"
	Function _iMeshBumpTextureReset(MESH:Byte Ptr)="iMeshBumpTextureReset"
	Function _iMeshTextureSwap(MESH:Byte Ptr,TEXTURE:Byte Ptr)="iMeshTextureSwap"
	Function _iMeshBumpTextureSwap(MESH:Byte Ptr,TEXTURE:Byte Ptr)="iMeshBumpTextureSwap"
	Function _iMeshTextureChange(MESH:Byte Ptr,texture_filename$z)="iMeshTextureChange"
	Function _iMeshAlphaTextureChange(MESH:Byte Ptr,texture_filename$z)="iMeshAlphaTextureChange"
	Function _iMeshTexturePath(MESH:Byte Ptr,path$z)="iMeshTexturePath"
	Function _iMeshTextureModeSet(MESH:Byte Ptr,mapping_mode:Int)="iMeshTextureModeSet"
	Function _iMeshTextureMipMapLodSet(MESH:Byte Ptr,LOD:Float)="iMeshTextureMipMapLodSet"
	Function _iMeshTextureSharingSet(bShare:Int)="iMeshTextureSharingSet"
	Function _iMeshBuffersSharingSet(bShare:Int)="iMeshBuffersSharingSet"
	Function _iMeshEnvMapReceiverAdd(MESH:Byte Ptr,ENVMAP:Byte Ptr)="iMeshEnvMapReceiverAdd"
	Function _iMeshEnvMapBlendSet(MESH:Byte Ptr,visibility:Float)="iMeshEnvMapBlendSet"
	Function _iMeshEnvMapGlassSet(MESH:Byte Ptr,refractionFactor:Float)="iMeshEnvMapGlassSet"
	Function _iMeshEnvMapCasterAdd(MESH:Byte Ptr)="iMeshEnvMapCasterAdd"
	Function _iMeshEnvMapCasterRemove(MESH:Byte Ptr)="iMeshEnvMapCasterRemove"
	Function _iMeshTransfer(MESH:Byte Ptr,BODY:Byte Ptr)="iMeshTransfer"
	Function _iMeshShadowCasterExtrusionSet(MESH:Byte Ptr,extrusion:Float)="iMeshShadowCasterExtrusionSet"
	Function _iMeshShadowCasterNormalsRecompute(MESH:Byte Ptr)="iMeshShadowCasterNormalsRecompute"

	' new in v4.1.0
	Function _iMeshPartCreate:Byte Ptr(x_filename$z,mapped_with_texture:Int)="iMeshPartCreate" ' returns MESH*
	Function _iMeshPartCreateFromMemory:Byte Ptr(x_file_memptr:Byte Ptr,x_memsize:Int,texture_file_memptr:Byte Ptr,texture_memsize:Int,texture_id:Int,mapped_with_texture:Int)="iMeshPartCreateFromMemory" ' returns MESH*
	
	' new in v5.1
	Function _iMeshBoundingSphere:Float(MESH:Byte Ptr,D3DXVECTOR3_center:Byte Ptr)="iMeshBoundingSphere"
EndExtern

Function iMeshVertexBufferDynamicMake(msh:MESH,bReadWrite:Int)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.VertexBufferDynamicMake(bReadWrite)
EndFunction

Function iMeshVertexBufferClose(msh:MESH)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.VertexBufferClose()
EndFunction

Function iMeshVertexBufferSize:Int(msh:MESH)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	Return msh.VertexBufferSize()
EndFunction

Function iMeshVertexBufferSizeSet(msh:MESH,vertices:Int)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.VertexBufferSizeSet(vertices)
EndFunction

Function iMeshFaceBufferDynamicMake(msh:MESH,bReadWrite:Int)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.FaceBufferDynamicMake(bReadWrite)
EndFunction

Function iMeshFaceBufferClose(msh:MESH)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.FaceBufferClose()
EndFunction

Function iMeshFaceBufferSize:Int(msh:MESH)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	Return msh.FaceBufferSize()
EndFunction

Function iMeshFaceBufferSizeSet(msh:MESH,faces:Int)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.FaceBufferSizeSet(faces)
EndFunction

Function iMeshVertexBufferOpen(msh:MESH,verts:MESHVERTEXBUFFER Var)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.VertexBufferOpen(verts)
EndFunction

Function iMeshVertexBufferOriginal(msh:MESH,verts:MESHVERTEXBUFFER Var)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.VertexBufferOriginal(verts)
EndFunction

Function iMeshFaceBufferOpen(msh:MESH,faces:MESHFACEBUFFER Var)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.FaceBufferOpen(faces)
EndFunction

Function iMeshFaceBufferOriginal(msh:MESH,faces:MESHFACEBUFFER Var)
	If Not msh
		DebugLog("MESH is Null")
		Return
	EndIf
	msh.FaceBufferOriginal(faces)
EndFunction

Type MESHVERTEXBUFFER 

	Const pX:Int = 0
	Const pY:Int = 1
	Const pZ:Int = 2
	Const nX:Int = 3
	Const nY:Int = 4
	Const nZ:Int = 5
	Const U:Int  = 6
	Const V:Int  = 7
	Const fld_cnt:Int = 8
	
	Field _ptr:Float Ptr
	
	Method get_pX:Float(idx:Int)			' returns MESHVERTEX[idx].p.x
		Return _ptr[idx*fld_cnt+pX]
	EndMethod
	Method set_pX(idx:Int,value:Float)		' sets MESHVERTEX[idx].p.x
		_ptr[idx*fld_cnt+pX]=value
	EndMethod
	Method get_pY:Float(idx:Int)			' returns MESHVERTEX[idx].p.y
		Return _ptr[idx*fld_cnt+pY]
	EndMethod
	Method set_pY(idx:Int,value:Float)		' sets MESHVERTEX[idx].p.y
		_ptr[idx*fld_cnt+pY]=value
	EndMethod
	Method get_pZ:Float(idx:Int)			' returns MESHVERTEX[idx].p.z
		Return _ptr[idx*fld_cnt+pZ]
	EndMethod
	Method set_pZ(idx:Int,value:Float)		' sets MESHVERTEX[idx].p.z
		_ptr[idx*fld_cnt+pZ]=value
	EndMethod

	Method getP:D3DXVECTOR3(idx:Int)		' returns MESHVERTEX[idx].p
		Return _D3DXVECTOR3(get_pX(idx),get_pY(idx),get_pZ(idx))
	EndMethod	
	Method setP(idx:Int,vect:D3DXVECTOR3)	' sets MESHVERTEX[idx].p
		set_pX(idx,vect.X)
		set_pY(idx,vect.Y)
		set_pZ(idx,vect.Z)
	EndMethod
		
	Method get_nX:Float(idx:Int)			' returns MESHVERTEX[idx].n.x
		Return _ptr[idx*fld_cnt+nX]
	EndMethod
	Method set_nX(idx:Int,value:Float)		' sets MESHVERTEX[idx].n.x
		_ptr[idx*fld_cnt+nX]=value
	EndMethod
	Method get_nY:Float(idx:Int)			' returns MESHVERTEX[idx].n.y
		Return _ptr[idx*fld_cnt+nY]
	EndMethod
	Method set_nY(idx:Int,value:Float)		' sets MESHVERTEX[idx].n.y
		_ptr[idx*fld_cnt+nY]=value
	EndMethod
	Method get_nZ:Float(idx:Int)			' returns MESHVERTEX[idx].n.z
		Return _ptr[idx*fld_cnt+nZ]
	EndMethod
	Method set_nZ(idx:Int,value:Float)		' sets MESHVERTEX[idx].n.z
		_ptr[idx*fld_cnt+nZ]=value
	EndMethod

	Method getN:D3DXVECTOR3(idx:Int)		' returns MESHVERTEX[idx].n
		Return _D3DXVECTOR3(get_nX(idx),get_nY(idx),get_nZ(idx))
	EndMethod	
	Method setN(idx:Int,vect:D3DXVECTOR3)	' sets MESHVERTEX[idx].n
		set_nX(idx,vect.X)
		set_nY(idx,vect.Y)
		set_nZ(idx,vect.Z)
	EndMethod
	
	Method get_U:Float(idx:Int)			' returns MESHVERTEX[idx].u
		Return _ptr[idx*fld_cnt+U]
	EndMethod
	Method set_U(idx:Int,value:Float)		' sets MESHVERTEX[idx].u
		_ptr[idx*fld_cnt+U]=value
	EndMethod
	Method get_V:Float(idx:Int)			' returns MESHVERTEX[idx].v
		Return _ptr[idx*fld_cnt+V]
	EndMethod
	Method set_V(idx:Int,value:Float)		' sets MESHVERTEX[idx].v
		_ptr[idx*fld_cnt+V]=value
	EndMethod
	
EndType

Function _MESHVERTEXBUFFER:MESHVERTEXBUFFER()
	Return _g_3IEngine._MESHVERTEXBUFFER()
EndFunction

Type MESHFACEBUFFER 

	Const v0:Int = 0
	Const v1:Int = 1
	Const v2:Int = 2
	Const fld_cnt:Int = 3
	
	Field _ptr:Short Ptr
	
	Method get_v0:Short(idx:Int)	' returns MESHFACE[idx].v0
		Return _ptr[idx*fld_cnt+v0]
	EndMethod
	Method set_v0(idx:Int,value:Float)	' sets MESHFACE[idx].v0
		_ptr[idx*fld_cnt+v0]=value
	EndMethod
	Method get_v1:Short(idx:Int)	' returns MESHFACE[idx].v1
		Return _ptr[idx*fld_cnt+v1]
	EndMethod
	Method set_v1(idx:Int,value:Float)	' sets MESHFACE[idx].v1
		_ptr[idx*fld_cnt+v1]=value
	EndMethod
	Method get_v2:Short(idx:Int)	' returns MESHFACE[idx].v2
		Return _ptr[idx*fld_cnt+v2]
	EndMethod
	Method set_v2(idx:Int,value:Float)	' sets MESHFACE[idx].v2
		_ptr[idx*fld_cnt+v2]=value
	EndMethod
EndType

Function _MESHFACEBUFFER:MESHFACEBUFFER()
	Return _g_3IEngine._MESHFACEBUFFER()
EndFunction

Extern

	' MESH-BUFFERS
	Function _iMeshVertexBufferDynamicMake(MESH:Byte Ptr,bReadWrite:Int)="iMeshVertexBufferDynamicMake"
	Function _iMeshVertexBufferOpen(MESH:Byte Ptr,MESHVERTEXBUFFER:Float Ptr Ptr)="iMeshVertexBufferOpen"
	Function _iMeshVertexBufferClose(MESH:Byte Ptr)="iMeshVertexBufferClose"
	Function _iMeshVertexBufferSize:Int(MESH:Byte Ptr)="iMeshVertexBufferSize"
	Function _iMeshVertexBufferSizeSet(MESH:Byte Ptr,vertices:Int)="iMeshVertexBufferSizeSet"
	Function _iMeshVertexBufferOriginal(MESH:Byte Ptr,MESHVERTEXBUFFER:Float Ptr Ptr)="iMeshVertexBufferOriginal"
	Function _iMeshFaceBufferDynamicMake(MESH:Byte Ptr,bReadWrite:Int)="iMeshFaceBufferDynamicMake"
	Function _iMeshFaceBufferOpen(MESH:Byte Ptr,MESHFACEBUFFER:Short Ptr Ptr)="iMeshFaceBufferOpen"
	Function _iMeshFaceBufferClose(MESH:Byte Ptr)="iMeshFaceBufferClose"
	Function _iMeshFaceBufferSize:Int(MESH:Byte Ptr)="iMeshFaceBufferSize"
	Function _iMeshFaceBufferSizeSet(MESH:Byte Ptr,faces:Int)="iMeshFaceBufferSizeSet"
	Function _iMeshFaceBufferOriginal(MESH:Byte Ptr,MESHFACEBUFFER:Short Ptr Ptr)="iMeshFaceBufferOriginal"
		
	Function sinf:Float(val:Float)
EndExtern

