' -------------------------------------------------------
' SKYBOX
' -------------------------------------------------------

Type SKYBOX Extends i3ImpactBase	

	Method Hide()
		If Not IsValid() RuntimeError "Invalid SkyBox"
		_iSkyBoxHide(objptr)
	EndMethod

	Method Show()
		If Not IsValid() RuntimeError "Invalid SkyBox"
		_iSkyBoxShow(objptr)
	EndMethod

	Method ColorSet(red:Float,green:Float,blue:Float)
		If Not IsValid() RuntimeError "Invalid SkyBox"
		_iSkyBoxColorSet(objptr,red,green,blue)
	EndMethod

	Method Destroy()
		If Not IsValid() RuntimeError "Invalid SkyBox"
		_iSkyBoxDestroy(objptr)
		objptr=Null
	EndMethod

	Method EnvMapCasterAdd()
		If Not IsValid() RuntimeError "Invalid SkyBox"
		_iSkyBoxEnvMapCasterAdd(objptr)
	EndMethod
	
	Method EnvMapCasterRemove()
		If Not IsValid() RuntimeError "Invalid SkyBox"
		_iSkyBoxEnvMapCasterRemove(objptr)
	EndMethod
						
EndType

Function iSkyBoxCreate:SKYBOX(sky_filename:String,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.SkyBoxCreate(sky_filename,generateFunc)
EndFunction

Function iSkyBoxHide(sb:SKYBOX)
	If Not sb RuntimeError "SkyBox is Null"
	sb.Hide()
EndFunction

Function iSkyBoxShow(sb:SKYBOX)
	If Not sb RuntimeError "SkyBox is Null"
	sb.Show()
EndFunction

Function iSkyBoxColorSet(sb:SKYBOX,red:Float,green:Float,blue:Float)
	If Not sb RuntimeError "SkyBox is Null"
	sb.ColorSet(red,green,blue)
EndFunction

Function iSkyBoxDestroy(sb:SKYBOX)
	If Not sb RuntimeError "SkyBox is Null"
	sb.Destroy()
EndFunction

Function iSkyBoxEnvMapCasterAdd(sb:SKYBOX)
	If Not sb RuntimeError "SkyBox is Null"
	sb.EnvMapCasterAdd()
EndFunction

Function iSkyBoxEnvMapCasterRemove(sb:SKYBOX)
	If Not sb RuntimeError "SkyBox is Null"
	sb.EnvMapCasterRemove()
EndFunction

Extern
	' SKYBOX
	Function _iSkyBoxCreate:Byte Ptr(sky_filename$z)="iSkyBoxCreate" ' returns SKYBOX*
	Function _iSkyBoxHide(SKYBOX:Byte Ptr)="iSkyBoxHide"
	Function _iSkyBoxShow(SKYBOX:Byte Ptr)="iSkyBoxShow"
	Function _iSkyBoxColorSet(SKYBOX:Byte Ptr,red:Float,green:Float,blue:Float)="iSkyBoxColorSet"
	Function _iSkyBoxDestroy(SKYBOX:Byte Ptr)="iSkyBoxDestroy"
	Function _iSkyBoxEnvMapCasterAdd(SKYBOX:Byte Ptr)="iSkyBoxEnvMapCasterAdd"
	Function _iSkyBoxEnvMapCasterRemove(SKYBOX:Byte Ptr)="iSkyBoxEnvMapCasterRemove"
EndExtern

