
Type SOUND Extends i3ImpactBase

	Function AudioIsAvailable:Int()
		Return _iAudioIsAvailable()
	EndFunction
	
	Function ListenerCameraSet(cam:CAMERA)
		_iListenerCameraSet(cam.objptr)
	EndFunction
	
	Function ListenerDopplerSet(dopplerFactor:Float)
		_iListenerDopplerSet(dopplerFactor)
	EndFunction

	Method Destroy()
		_iSoundDestroy(objptr)
		objptr=Null
	EndMethod
	
	Method Play(bLooping:Int)
		_iSoundPlay(objptr,bLooping)
	EndMethod
	
	Method PlayNow(bLooping:Int)
		_iSoundPlayNow(objptr,bLooping)
	EndMethod
	
	Method Playing:Int()
		Return _iSoundPlaying(objptr)
	EndMethod
	
	Method Stop(resetLocation:Int)
		_iSoundStop(objptr,resetLocation)
	EndMethod
	
	Method LocationSet(location:D3DXVECTOR3)
		_iSoundLocationSet(objptr,location.param())
	EndMethod
	
	Method VelocitySet(velocity:D3DXVECTOR3)
		_iSoundVelocitySet(objptr,velocity.param())
	EndMethod
	
	Method FrequencySet(frequency:Int)
		_iSoundFrequencySet(objptr,frequency)
	EndMethod
	
	Method VolumeSet(volume:Float)
		_iSoundVolumeSet(objptr,volume)
	EndMethod

	Method Frequency:Int()
		Return _iSoundFrequency(objptr)
	EndMethod
EndType

Function iAudioIsAvailable:Int()
	Return SOUND.AudioIsAvailable()
EndFunction

Function iListenerCameraSet(cam:CAMERA)
	SOUND.ListenerCameraSet(cam)
EndFunction

Function iListenerDopplerSet(dopplerFactor:Float)
	SOUND.ListenerDopplerSet(dopplerFactor)
EndFunction

Function iSoundCreate:SOUND(pcm_filename:String,b3DSound:Int,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.SoundCreate(pcm_filename,b3DSound,generateFunc) 
EndFunction

Function iSoundOggCreate:SOUND(ogg_filename:String,b3DSound:Int,bufferSize:Int=0,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.SoundOggCreate(ogg_filename,b3DSound,bufferSize,generateFunc) 
EndFunction

Function iSoundOggCreateFromMemory:SOUND(ogg_memfile_ptr:Byte Ptr,ogg_memsize:Int,b3DSound:Int,bufferSize:Int,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.SoundOggCreateFromMemory(ogg_memfile_ptr,ogg_memsize,b3DSound,bufferSize,generateFunc)
EndFunction

Function iSoundDestroy(snd:SOUND)
	snd.Destroy()
EndFunction

Function iSoundPlay(snd:SOUND,bLooping:Int)
	snd.Play(bLooping)
EndFunction

Function iSoundPlayNow(snd:SOUND,bLooping:Int)
	snd.PlayNow(bLooping)
EndFunction

Function iSoundPlaying:Int(snd:SOUND)
	Return snd.Playing()
EndFunction

Function iSoundStop(snd:SOUND,resetLocation:Int)
	If snd=Null
		_iSoundStop(Null,0)
	Else
		snd.Stop(resetLocation)
	EndIf
EndFunction

Function iSoundLocationSet(snd:SOUND,location:D3DXVECTOR3)
	snd.LocationSet(location)
EndFunction

Function iSoundVelocitySet(snd:SOUND,velocity:D3DXVECTOR3)
	snd.VelocitySet(velocity)
EndFunction

Function iSoundFrequencySet(snd:SOUND,frequency:Int)
	snd.FrequencySet(frequency)
EndFunction

Function iSoundVolumeSet(snd:SOUND,volume:Float)
	snd.VolumeSet(volume)
EndFunction

Function iSoundFrequency:Int(snd:SOUND)
	Return snd.Frequency()
EndFunction

Extern

	' SOUND
	Function _iAudioIsAvailable:Int()="iAudioIsAvailable" ' returns true/false
	Function _iListenerCameraSet(CAMERA:Byte Ptr)="iListenerCameraSet"
	Function _iListenerDopplerSet(dopplerFactor:Float)="iListenerDopplerSet"
	Function _iSoundCreate:Byte Ptr(pcm_filename$z,b3DSound:Int)="iSoundCreate" ' returns SOUND* 
	Function _iSoundOggCreate:Byte Ptr(ogg_filename$z,b3DSound:Int,bufferSize:Int=0)="iSoundOggCreate" ' returns SOUND* 
	Function _iSoundOggCreateFromMemory:Byte Ptr(ogg_memfile_ptr:Byte Ptr,ogg_memsize:Int,b3DSound:Int,bufferSize:Int)="iSoundOggCreateFromMemory" ' returns SOUND* 
	Function _iSoundDestroy(SOUND:Byte Ptr)="iSoundDestroy"
	Function _iSoundPlay(SOUND:Byte Ptr,bLooping:Int)="iSoundPlay"
	Function _iSoundPlayNow(SOUND:Byte Ptr,bLooping:Int)="iSoundPlayNow"
	Function _iSoundPlaying:Int(SOUND:Byte Ptr)="iSoundPlaying" ' returns true/false	
	Function _iSoundStop(SOUND:Byte Ptr,resetLocation:Int)="iSoundStop"
	Function _iSoundLocationSet(SOUND:Byte Ptr,D3DXVECTOR3_location:Byte Ptr)="iSoundLocationSet"
	Function _iSoundVelocitySet(SOUND:Byte Ptr,D3DXVECTOR3_velocity:Byte Ptr)="iSoundVelocitySet"
	Function _iSoundFrequencySet(SOUND:Byte Ptr,frequency:Int)="iSoundFrequencySet"
	Function _iSoundVolumeSet(SOUND:Byte Ptr,volume:Float)="iSoundVolumeSet"
	Function _iSoundFrequency:Int(SOUND:Byte Ptr)="iSoundFrequency"
	
EndExtern
