
Type SPRING Extends i3ImpactBase

	Method Destroy()
		_iSpringDestroy(objptr)
		objptr=Null
	EndMethod
	
	Method Disable()
		_iSpringDisable(objptr)
	EndMethod
	
	Method Enable()
		_iSpringEnable(objptr)
	EndMethod
	
	Method BodySet(bdy:BODY,location:D3DXVECTOR3)
		_iSpringBodySet(objptr,bdy.objptr,location.param())
	EndMethod
	
	Method TargetBodySet(bdy:BODY,targetBodyObject:D3DXVECTOR3)
		If bdy=Null Then bdy=New BODY
		_iSpringTargetBodySet(objptr,bdy.objptr,targetBodyObject.param())
	EndMethod
	
	Method Set(springFactor:Float)
		_iSpringSet(objptr,springFactor)
	EndMethod
	
	Method DampingSet(dampingFactor:Float)
		_iSpringDampingSet(objptr,dampingFactor)
	EndMethod

EndType

' SPRINGS 
Function iSpringCreate:SPRING(bdy:BODY,location:D3DXVECTOR3,targetObject:BODY,springTarget:D3DXVECTOR3,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.SpringCreate(bdy,location,targetObject,springTarget,generateFunc) 
EndFunction

Function iSpringDestroy(sprng:SPRING)
	sprng.Destroy()
EndFunction

Function iSpringDisable(sprng:SPRING)
	sprng.Disable()
EndFunction

Function iSpringEnable(sprng:SPRING)
	sprng.Enable()
EndFunction

Function iSpringBodySet(sprng:SPRING,bdy:BODY,location:D3DXVECTOR3)
	sprng.BodySet(bdy,location)
EndFunction

Function iSpringTargetBodySet(sprng:SPRING,bdy:BODY,targetBodyObject:D3DXVECTOR3)
	sprng.TargetBodySet(bdy,targetBodyObject)
EndFunction

Function iSpringSet(sprng:SPRING,springFactor:Float)
	sprng.Set(springFactor)
EndFunction

Function iSpringDampingSet(sprng:SPRING,dampingFactor:Float)
	sprng.DampingSet(dampingFactor)
EndFunction

Extern

	' SPRINGS 
	Function _iSpringCreate:Byte Ptr(BODY:Byte Ptr,D3DXVECTOR3_location:Byte Ptr,BODY_targetObject:Byte Ptr,D3DXVECTOR3_springTarget:Byte Ptr)="iSpringCreate" ' returns SPRING*

	Function _iSpringDestroy(SPRING:Byte Ptr)="iSpringDestroy"
	Function _iSpringDisable(SPRING:Byte Ptr)="iSpringDisable"
	Function _iSpringEnable(SPRING:Byte Ptr)="iSpringEnable"
	Function _iSpringBodySet(SPRING:Byte Ptr,BODY:Byte Ptr,D3DXVECTOR3_location:Byte Ptr)="iSpringBodySet"
	Function _iSpringTargetBodySet(SPRING:Byte Ptr,BODY:Byte Ptr,D3DXVECTOR3_targetBodyObject:Byte Ptr)="iSpringTargetBodySet"
	Function _iSpringSet(SPRING:Byte Ptr,springFactor:Float)="iSpringSet"
	Function _iSpringDampingSet(SPRING:Byte Ptr,dampingFactor:Float)="iSpringDampingSet"

EndExtern
